<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--OrphanRequest.jsp

Copyright (C) 2001 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2001 Xerox Corporation. All Rights Reserved.

Author: Philip Gust
Version: $Id: OrphanDraftRequest.jsp 93076 2015-12-03 08:10:45Z bchan $
-->
<!--
This file receives notification messages from workflow activities
and queues the events for the recipient
-->

<html xmlns="http://www.w3.org/1999/xhtml">

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.property.*" %>
<%@ page import="com.xerox.docushare.impl.util.*" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% 
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();

try { 
    dsrouting.setDSSession(request); 
}catch(DSAuthorizationException ex) {//AR20164+
    response.setContentType(dsrouting.getContentType()); //AR20163
    out.print(MessageDB.get("routing_not_authorized", locale));
    return;
}

String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+
String requestURL = dsrouting.getRequestURL(request);
String contextPath = request.getContextPath();
%>

<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
    <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>

<%
// set recipient from logged user
final DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
final String recipient = dsUser.getHandle().toExternalForm();
final String recipientName = GenericUtil.getShortName(dsUser, dsSession);

final String requestType = "OrphanRequest";
final String requestTitle = MessageDB.get("routing_unpublished_document", locale);

String userName = recipientName;

String cssPath = "";
String headerLogo = "";
if (dsSession != null && dsSession.isEnabled(DSLicenseCodes.NX)) {
	cssPath = "docushare_cpx.css";
}
else{
	cssPath = "docushare.css";
	headerLogo ="<image src=" + request.getContextPath() + "/images/header_logo.png style=margin-bottom:5px; border=0 alt=Xerox DocuShare title=Xerox DocuShare>";
}
%>

<HEAD>
   <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html">
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>
  
   <TITLE><%= MessageDB.get("routing_for_information_title", locale) %></TITLE>

<script language="javascript">
<!--
// These files included in JSP because they use request.getContextPath()

// JavaScript for document routing functions
<%@include file="document_routing.js" %>

/**
 * Confirm whether to delete unpublished documents before deleting this job
 *
 * @param unpublishedCount the number of unpublished documents being deleted
 * @return <tt>true</tt> if no unpublished documents or user OKs deletion
 */
function confirmDeleteUnpublished(unpublishedCount)
{
    var status = true;
    if (unpublishedCount > 0) {
        <%// Singapore team AR2910 on unix platform, for unpublished Document, click Acknowledged gives error%>
        status = window.confirm("<%= MessageDB.get("routing_ok_delete_unpublished", locale) %>");
        <%// AR2910 End%>
    }
    return status;
}
//-->
</script>
</HEAD>

<%
final String document = request.getParameter("document");
final String routingSlipRequestID = request.getParameter("routingSlipRequestID");
final String status = request.getParameter(requestType); //"OrphanRequest"

if (dsrouting == null) {
%>
<script language="javascript">
<!--
    writeError(document, '<%= recipientName %>', 'Error', '<%= MessageDB.get("routing_contact_failed", locale) %>');
//-->
</script>
<%
} else if (document == null) {
%>
<script language="javascript">
<!--
writeError(document, '<%= recipientName %>', 'Internal Error', '<%= MessageDB.get("routing_missing_document", locale) %>');
//-->
</script>
<%
} else if (routingSlipRequestID == null) {
%>
<script language="javascript">
<!--
writeError(document, '<%= recipientName %>', 'Internal Error', '<%= MessageDB.get("routing_error_missing_parameter", locale) %>');
//-->
</script>
<%
// handle results of form submission
} else if (status != null) {
    boolean error = false;

    // remove notification
    //2004 June 14-: dsrouting.removeWorkFlowTaskForUser(recipient, routingSlipRequestID, requestType, status);
    dsrouting.removeWorkFlowTaskForUser(recipient, routingSlipRequestID, status); //2004 June 14+

    try {
        //DSVersion dsVer = (DSVersion)dsSession.getObject(new DSHandle(document));
        //DSDocument dsDoc = dsVer.getDocument(DSSelectSet.NO_PROPERTIES);
        DSDocument dsDoc = (DSDocument)dsSession.getObject(new DSHandle(document), DSSelectSet.NO_PROPERTIES);

        if (dsDoc!=null && dsDoc.isDraft() && (dsrouting.getWorkFlowJobsForDocument(document).length == 0)) {
            // ok to delete once user has had a chance at publishing or routing
            dsSession.deleteObject(dsDoc.getHandle(), DSSelectSet.NO_PROPERTIES);
        }
    } catch (Exception ex) {
        System.out.println("OrphanDraftRequest getObject & deleteObject:" + ex);
        //error = true;
%>
<script language="javascript">
<!--
        writeError(document, '<%= recipientName %>', 'Error', '<%= ex.getMessage() %>');
//-->
</script>
<%
    }
%>
<script language="javascript">
<!--
    if (self.opener) {
        self.opener.location = self.opener.location;
    }
<%
    if (!error) {
%>
        window.close();
<%
    }
%>
//-->
</script>
<%
} else { //display
    try {
%>

<body>
    <div id="header">
        <h1>DocuShare</h1>
        <h2>Orphan Draft Request</h2>
        <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
    </div>    

    <div id="content">
    <h2><%= requestTitle %></h2>
    
<%
        //RoutingSlipRequest rsRequest = dsrouting.getRoutingSlipRequestForUser(recipient,routingSlipRequestID);
        int rsRequest = dsrouting.getWorkFlowTaskForUser(recipient,routingSlipRequestID);
        String subject = dsrouting.getTaskDescription(rsRequest);
        Date requestTime = dsrouting.getTaskCreationTime(rsRequest);
        String requestTimeStr = new SimpleDateFormat(MessageDB.get("date_time_full"+keySuffix, locale), locale).format(requestTime);
%>
    <p>
    <strong><%= MessageDB.get("prop.label.linksFromAbbr", locale) %>:</strong>&nbsp;<%= MessageDB.get("routing_service", locale) %><br />
    <strong><%= MessageDB.get("routing_subject", locale) %>:</strong>&nbsp;<%= subject %><br />
    <strong><%= MessageDB.get("date_label", locale) %>:</strong>&nbsp;<%= requestTimeStr %><br /> 
    </p>
<%
        DSURLInfo urlInfo = (DSURLInfo) request.getAttribute("DSURLInfo");

        // get the draft version for the routing slip, document, and recipient
        DSHandle dsHandle = new DSHandle(document);
        //DSVersion dsVersion = (DSVersion)dsSession.getObject(dsHandle);
        DSDocument dsDoc = null;
        DSVersion dsVersion = null;
        try{
            dsDoc = (DSDocument)dsSession.getObject(dsHandle, DSSelectSet.NO_PROPERTIES); //draftHandle
            dsVersion = dsDoc.getPreferredVersion(null);
        }catch(com.xerox.docushare.db.DatabaseException ex) {
            System.out.println(document + ": " + MessageDB.get("routing_deleted", locale));
            //return;
        }catch(Exception ex) {
            System.out.println(document + ": " + ex);
            //return;
        }

        // get preferred file name for use in GET request
        String versionFileName = subject;
        if(dsVersion != null)
            versionFileName = dsVersion.getPreferredRendition(DSSelectSet.NO_PROPERTIES).getContentElements()[0].getPreferredFileName();
        versionFileName = dsrouting.removePoisonChars(versionFileName); //AR11042+

        // get the icon, title and summary for the draft version
        String docIcon = contextPath + "/images/small/page.png";
        if (urlInfo != null) {
            try {
                java.net.URL docIconURL = new java.net.URL(urlInfo.getURLInfo(dsHandle)[0]);
                docIcon = docIconURL.getPath();
            } catch (Exception ex) {
            }
        }
        String docTitle = null;
        String docSummary = null;
        if(dsVersion != null) {
            docTitle = dsVersion.getTitle();
            docSummary = dsVersion.getSummary();
        }else //dsVersion is null
            docTitle = subject + ": " + MessageDB.get("routing_deleted", locale);

        int unpublishedCount = 0;
        //DSDocument dsDoc = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);

        if (dsDoc!=null && dsDoc.isDraft()) {
            // count the number of unpublished documents
            unpublishedCount++;
            if (dsrouting.getWorkFlowJobsForDocument(document).length == 0) {
%>
    <p><%= MessageDB.get("routing_orphan_unpublished_unrouted", locale) %></p>
<%
            } else {
%>
    <p><%= MessageDB.get("routing_orphan_unpublished_routed", locale) %></p>
<%
            }
        } else {//not draft
%>
    <p><%= MessageDB.get("routing_orphan_routed", locale) %></p>
<%
        }
%>
    <table class="colltable">
        <col class="col_actions" />
        <col class="col_actions" />
        <tr>
            <th><%=MessageDB.get("routing_type", locale)%></th>
            <th class="name"><%=MessageDB.get("routing_title", locale)%></th>
            <th class="actions"><%=MessageDB.get("Actions", locale)%></th> 
        </tr>
    <tr>
    <td class="icon">
<%
if (dsDoc!=null){%>
        <a href="<%= contextPath %>/dsweb/Get/<%= document %>/<%= versionFileName %>" target="_new">
        <%}%>
        <img <%= browserInfo.getImgWrapper(docIcon) %> alt="<%= MessageDB.get("Document", locale) %>" title="<%= MessageDB.get("Document", locale) %>" border="0" />
        </a>
    </TD>
    
    <td class="name">
<%if (dsDoc!=null){%>
        <a class="uline" href="<%= contextPath %>/dsweb/Get/<%= document %>/<%= versionFileName %>" target="_new">
<%}%>
        <%= AmberUtility.xss_safe_value(docTitle) %>
        </a>
<%
        if (unpublishedCount > 0) {
%>
        <font color="red"><strong>&nbsp;(<%= MessageDB.get("routing_unpublished", locale) %>)</strong></font>
<%
        }

        if (docSummary != null) {%>
            <p><%= AmberUtility.xss_safe_value(docSummary) %></p>
        <%}
        String sProperties = MessageDB.get("routing_tooltip_properties", locale); //SDL AR9150+
        String sViewHTML = MessageDB.get("routing_tooltip_view_html", locale); //SDL AR9150+
        String sRoute = MessageDB.get("routing_route", locale); //AR20133+
%>
    </td>
    
    <td class="actions"> 
<%if (dsDoc!=null){%>
<a href='prop_all.jsp?document=<%= document %>&return=<%= java.net.URLEncoder.encode("OrphanDraftRequest.jsp?" + request.getQueryString(), "UTF-8") %>&returnTag=<%= java.net.URLEncoder.encode(requestTitle, "UTF-8") %>&<%= request.getQueryString() %>'>
<img <%= browserInfo.getImgWrapper(contextPath + "/images/action_properties.gif") %> alt="<%=sProperties%>" title="<%=sProperties%>" border="0" /></a>

<script type="text/javascript" src="<%=contextPath%>/javascript/common/ds_routing.js"> </script>
<a class="VariableWidth9URL" href="javascript:openRoutingSlip('<%=contextPath%>/', '<%= document %>')">
<img <%= browserInfo.getImgWrapper(contextPath + "/images/action_routing.gif") %> border="0" alt="<%=sRoute%>" title="<%=sRoute%>"></a>
<%}%>
<%
    try{
        boolean enableHtmlview = jp.co.fujixerox.docushare.amber.ConfigManager.getInstance().getDSConfig().enableHtmlview (dsSession); //AR8883+
        if(dsVersion == null)
            enableHtmlview = false;
        else
            enableHtmlview = enableHtmlview && !dsVersion.getIsRecord(); //AR9778+
        if (enableHtmlview && urlInfo.is_viewable(dsHandle)) {
%>
<a href="<%= contextPath %>/dsweb/Get/<%= document %>/html" target="_new">
<img <%= browserInfo.getImgWrapper(contextPath + "/images/action_viewweb.gif") %> alt="<%=sViewHTML%>" title="<%=sViewHTML%>" border="0" /></a>
<%
        }
        //AR9639 PDF icon:
        if(dsVersion == null){
            String sourceMimeType = dsVersion.getPreferredRendition(new DSSelectSet(DSRendition.rendition_type)).getRenditionType();
            boolean viewPdf = dsSession.canConvert(sourceMimeType, "application/pdf") && !dsVersion.getIsRecord();
            String sViewPDF = MessageDB.get("routing_tooltip_view_pdf", locale);
            if (viewPdf) {%>
                <a href="<%= contextPath %>/dsweb/Get/<%= document %>/pdf" target="_new">
                <img <%= browserInfo.getImgWrapper(contextPath + "/images/action_viewPDF.gif") %> alt="<%=sViewPDF%>" title="<%=sViewPDF%>" border="0" width="20" height="20"></a>
            <%}
        }
        //end AR9639
    }catch(Exception ev) { System.out.println("urlInfo.is_viewable: "+ev); }
%>
<%
String acknowledge = MessageDB.get("routing_acknowledged", locale);
String acknowledge_later = MessageDB.get("routing_acknowledge_later", locale);
%>
</TD>
</TR>
</TABLE>

<form action="OrphanDraftRequest.jsp" target="_top" method="GET">
<div id="buttonbar">

<!--AR5411-
<%if(!btnReadOnly){//AR6202+ %>
<input type="submit" name="<%= requestType %>" value="<%= acknowledge %>" class="bs"  onClick="return confirmDeleteUnpublished(<%= unpublishedCount %>)" />&nbsp;
<%}//AR6202+ %>
<input type="submit" name="<%= requestType %>" value="<%= acknowledge_later %>" onClick="window.close(); return false;" />
-->
<!--AR5411+-->
<%if(!btnReadOnly){//AR6202+ %>
<input type="submit" name="submitbutton" value="<%= acknowledge %>" class="bs" onClick="form.<%= requestType %>.value='Acknowledged'" />&nbsp;
<%}//AR6202+ %>
<input type="submit" name="submitbutton" value="<%= acknowledge_later %>" onClick="form.<%= requestType %>.value='Acknowledge Later';window.close(); return false;" />
<input type="hidden" name="<%= requestType %>", value="" />
<!--end AR5411+-->

</div>

<input type="hidden" name="routingSlipRequestID", value="<%= routingSlipRequestID %>" />
<input type="hidden" name="document", value="<%= document %>" />
</form>
<%
    } catch (java.rmi.RemoteException ex) {
%>
        writeError(document, '<%= recipientName %>', 'Error', '<%= MessageDB.get("routing_error_accessing_processor", locale) %>');
<%
    }
}
%>
		<p class="routing_wizard_copyright"><%= MessageDB.get("xerox_copyright", locale) %></p>
  </div>
	</body>
</html>
