<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- report_base.jsp

Copyright (C) 2004 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2004 Xerox Corporation. All Rights Reserved.

Version: $Id: report_base.jsp 102497 2017-03-20 10:01:44Z chuang $
-->

<!--
This file is the base report processor that receives notification
messages from workflow activities and queues the events for the recipient.
The report is customized through the following attributes:

DSSession:               the current DocuShare session
AdminSession:            the current DocuShare session
reportTitle:             title displayed for a summary job report
reportType:              type of report (e.g.: "ForApprovalOrderedReport")

and the following parameters:

routingSlipRequestID:    requestID if this report is from a request
aboutRecipient:          parameter set if this is a response from a specific recipient
workFlowJobName:         name of workflow job
-->

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.property.*" %>
<%@ page import="com.xerox.docushare.impl.util.*" %>
<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>

<%@ page import="jp.co.fujixerox.docushare.amber.*" %>
<%@ page import="jp.co.fujixerox.docushare.amber.vdf.*" %>
<%@ page import="jp.co.fujixerox.docushare.amber.object.VDFRequestImpl" %>

<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.text.SimpleDateFormat" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% 
long t0 = System.currentTimeMillis();
// set recipient from logged user
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
final DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();

// AR 27201 using new date-picker.js from common folder and translations from javascriptMessages.vdf
final WebRequest webRequest = (WebRequest)request.getAttribute("WebSession");
final VDF vdfInst = webRequest.getVDFSession().lookupVDF("javascriptMessages");
final VDFRequestImpl vdfRequest = new VDFRequestImpl(webRequest.getVDFSession());
final VDFContext vdfContext = new VDFContext(vdfInst, webRequest.getVDFSession(), vdfRequest);

boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";

try{
    dsrouting.setDSSession(request);    
}catch(DSAuthorizationException e){
    response.setContentType(dsrouting.getContentType()); //AR20163
    out.print(MessageDB.get("routing_not_authorized", locale));
    return;
}
String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+
String requestURL = dsrouting.getRequestURL(request);
String contextPath = request.getContextPath();
%>

<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
    <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>

<%
final DSUser dsRecipient = (DSUser)dsSession.getLoginPrincipal();
final String recipient = dsRecipient.getHandle().toExternalForm();
final String recipientName = dsRecipient.getUserName();
//AR6391+:
boolean isOwnerOrAdmin = false;
try{if(dsRecipient.isAdmin(DSLoginPrincipal.CONTENT_ADMIN)) isOwnerOrAdmin = true;
}catch(Exception ex) {}
//end AR6391+

// customizes report for specific report type
//AR6223-: final String reportType = (String)request.getAttribute("reportType");
//AR6223-: String requestedTitle = (String)request.getAttribute("reportTitle");
//AR6223+:
final String reportType = ""+ (String)request.getParameter("reportType");
String requestedTitle = "";
if(reportType.length()>4) requestedTitle = "routing_for"+ reportType.substring(3);
//end AR6223+

String reportTitle = requestedTitle;
try {
    reportTitle = MessageDB.get(requestedTitle, locale);
} catch (Exception e) {}

// status constants used by the report
final String deleteThisJobStatus = MessageDB.get("routing_delete_job", locale);
final String terminateThisJobStatus = MessageDB.get("routing_terminate_job", locale);
final String acknowledgedStatus = MessageDB.get("routing_acknowledged", locale);
final String closeStatus = MessageDB.get("button.close", locale);

// old netscape (5.x series and below) does not support IFRAME tag
final String browserType = (String)browserInfo.getProperty("browserType");
final int majorVersion = browserInfo.getPropertyAsInt("majorVersion");
final int minorVersion = browserInfo.getPropertyAsInt("minorVersion");
final boolean isOldNetscape = "Netscape".equals(browserType) && (majorVersion <= 4);

// older netscape (6.1 series and below) requires custom field sizing
final boolean isOlderNetscape = isOldNetscape || "Netscape".equals(browserType) && (majorVersion == 6) && (minorVersion == 1);

// Singapore Team AR3684 SPAR C17758 - Routing: Route in order does not expose user comments to recipients
int iCommentCount = 0;
%>

<html xmlns="http://www.w3.org/1999/xhtml">

<HEAD>
   <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>
  
   <TITLE><%= reportTitle %></TITLE>

<!-- import the code for creating the the popup calendar -->
<!--
<SCRIPT LANGUAGE="javascript" SRC="calendar.js"></script>
-->
<%
String fileSeparator = System.getProperty("file.separator").equals("/")?"/":"\\";
%>

<%/* Singapore team AR3566 */%>
<%/* Singapore team AR3299 */%>

<%!
    class StepComparator implements Comparator<String> {
		public int compare(String s1, String s2) {	    		  
			Integer  i1 = Integer.parseInt(s1.substring(s1.indexOf('(')+1, s1.indexOf('.')));
			Integer  i2 = Integer.parseInt(s2.substring(s2.indexOf('(')+1, s2.indexOf('.')));
			return i1.compareTo(i2);	
		}
	}//AR35868
%>

<script language="javascript">
<!--
// These files included in JSP because they use request.getContextPath()

// JavaScript for document routing functions
<%@include file="document_routing.js" %>

/**
 * Confirm whether to delete unpublished documents before deleting this job
 *
 * @param unpublishedCount the number of unpublished documents being deleted
 * @return <tt>true</tt> if no unpublished documents or user OKs deletion
 */
function confirmDeleteUnpublished(unpublishedCount)
{
    var status = true;
    //if (unpublishedCount > 0) { //AR5042-
    //AR5395-: if (unpublishedCount > 0 && !reportType.equals("ForReviewCompletion")) { //AR5042+
    if (unpublishedCount > 0 && <%=!reportType.equals("ForReviewCompletion")%>) { //AR5042+ //AR5395+
        var msg = "<%= MessageDB.get("routing_delete_confirm", locale) %>";
        status = window.confirm(msg);
    }
    return status;
}

/**
 * Confirm whether to terminate this job
 *
 * @return <tt>true</tt> if OK to terminate
 */
function confirmTerminateJob()
{
    var msg = "<%= MessageDB.get("routing_ok_to_terminate", locale) %>";
    var status = window.confirm(msg);
    return status;
}

/**
 * Body onLoad method
 */
function bodyLoaded()
{
    if (document.routingForm.byDate) {
        document.routingForm.byDate.focus();
    }
}

function datePicked()
{
  document.routingForm.submit();
}
    //-->
    </script>
    
<!-- AR 27201 using new date-picker.js from common folder and translations from javascriptMessages.vdf -->    
  <script type="text/javascript"> //<![CDATA[
    var dsDatePicker = {
       january : "<%=(String) vdfContext.lookupDefinition("january").getDefinition()%>",
       february : "<%=(String) vdfContext.lookupDefinition("february").getDefinition()%>",
       march : "<%=(String) vdfContext.lookupDefinition("march").getDefinition()%>",
       april : "<%=(String) vdfContext.lookupDefinition("april").getDefinition()%>",
       may : "<%=(String) vdfContext.lookupDefinition("may").getDefinition()%>",
       june : "<%=(String) vdfContext.lookupDefinition("june").getDefinition()%>",
       july : "<%=(String) vdfContext.lookupDefinition("july").getDefinition()%>",
       august : "<%=(String) vdfContext.lookupDefinition("august").getDefinition()%>",
       september : "<%=(String) vdfContext.lookupDefinition("september").getDefinition()%>",
       october : "<%=(String) vdfContext.lookupDefinition("october").getDefinition()%>",
       november : "<%=(String) vdfContext.lookupDefinition("november").getDefinition()%>",
       december : "<%=(String) vdfContext.lookupDefinition("december").getDefinition()%>",
       sun : "<%=(String) vdfContext.lookupDefinition("sun").getDefinition()%>",
       mon : "<%=(String) vdfContext.lookupDefinition("mon").getDefinition()%>",
       tue : "<%=(String) vdfContext.lookupDefinition("tue").getDefinition()%>",
       wed : "<%=(String) vdfContext.lookupDefinition("wed").getDefinition()%>",
       thu : "<%=(String) vdfContext.lookupDefinition("thu").getDefinition()%>",
       fri : "<%=(String) vdfContext.lookupDefinition("fri").getDefinition()%>",
       sat : "<%=(String) vdfContext.lookupDefinition("sat").getDefinition()%>",
       Calendar_label : "<%=(String) vdfContext.lookupDefinition("Calendar_label").getDefinition()%>",
       prevYear_label : "<%=(String) vdfContext.lookupDefinition("prevYear_label").getDefinition()%>",
       prevMonth_label : "<%=(String) vdfContext.lookupDefinition("prevMonth_label").getDefinition()%>",
       nextMonth_label : "<%=(String) vdfContext.lookupDefinition("nextMonth_label").getDefinition()%>",
       nextYear_label : "<%=(String) vdfContext.lookupDefinition("nextYear_label").getDefinition()%>",
       theme_url : "<%=request.getContextPath()%>/themes/<%=theme_name%>/"
    };
    //]]>
  </script>
  
</HEAD>

<script language="JavaScript" src="<%=request.getContextPath()%>/javascript/common/date-picker.js"> </script>

<%
// requestID if this is a request
final String routingSlipRequestID = request.getParameter("routingSlipRequestID");
final String notifyID = request.getParameter("notifyID");

// if this is a report about a specific recipient's response
// Singapore team AR2696 need to set Recipient to null if Recipient is deleted,
// cannot put as final as user can be deleted but aboutRecipient is not null.
String aboutRecipient = request.getParameter("aboutRecipient");
String aboutTask = request.getParameter("aboutTask"); //one slip can have same recipient in different tasks
if(aboutTask == null) aboutTask = request.getParameter("routingSlipRequestID"); //AR6977+

// name of workflow job -- not specified for recipient report from a summary request
final String workFlowJobName = request.getParameter("workFlowJobName");
final String routingSlipIDStr = request.getParameter("routingSlipID");
final String byDateStr = request.getParameter("byDate");  // set by form on this page to changed date

// the type of report (e.g. 'ForReview')
String status = request.getParameter(reportType);

boolean refreshOpener = false;   // set to true if refresh is required
boolean closeWindow = false;     // set to true to close this window

int routingSlip = 0;

if (dsrouting != null) {
    if (routingSlipRequestID != null) {
        int taskId = Integer.parseInt(routingSlipRequestID);
        routingSlip = dsrouting.getWorkFlowForWorkFlowTask(taskId);
    } else if (workFlowJobName != null) {
        routingSlip = Integer.parseInt(workFlowJobName);
    }
}

if (dsrouting == null) {
%>
<script language="javascript">
<!--
    writeError(document, '<%= recipientName %>', 'Error', 'Cannot contact routing slip processor.  Please notify your DocuShare administrator.');
//-->
</script>
<%
} else if (routingSlip == 0) {
%>
<script language="javascript">
<!--
    writeError(document, '<%= recipientName %>', 'Error', 'Routing slip no longer available.  Please notify DocuShare customer support.');
//-->
</script>
<%
} else if (recipient == null) {
%>
<script language="javascript">
<!--
writeError(document, '<%= recipientName %>', 'Internal Error', 'Missing parameter: "recipient".  Please notify DocuShare customer support.');
//-->
</script>
<%
} else {//dsrouting, routingSlip, recipient not null
        // handle results of form submission
        if (status != null) {
            if (status.equals(acknowledgedStatus)) {
                if (routingSlipRequestID != null) {
                    // remove routing slip request for recipient
                    // Singapore team AR5253 on all language, on W2k, click acknowledge on response doesn't work
                    //AR6223-: dsrouting.removeWorkFlowTaskForUser(recipient, routingSlipRequestID, reportType, "Acknowledged");
                    if(notifyID != null)
                      dsrouting.removeWorkFlowTaskForUser(recipient, notifyID, "NotificationAcknowledged");
                    else
                      dsrouting.removeWorkFlowTaskForUser(recipient, routingSlipRequestID, "NotificationAcknowledged"); //AR6223+
                    refreshOpener = true;
                    closeWindow = true;

                } else {%>
                    <script language="javascript">
                    <!--
                    writeError(document, '<%= recipientName %>', 'Internal Error', 'Missing parameter: "routingSlipRequestID".  Please notify DocuShare customer support.');
                    //-->
                    </script>
                <%}
            } else if (status.equals(deleteThisJobStatus)) {
                // remove the completed workflow job
                dsrouting.removeWorkFlowJob(workFlowJobName);
                refreshOpener = true;
                closeWindow = true;

            } else if (status.equals(terminateThisJobStatus)) {
                dsrouting.terminateWorkFlowJob(workFlowJobName);
                refreshOpener = true;

            } else if (status.equals(closeStatus)) {
                closeWindow = true;
            }
        }// end handle results of form submission

    HashMap routingMap = dsrouting.getRoutingInfo(routingSlip);

    boolean isRecipientRemoved = false; //handled in each recipient row. 
    boolean deletedWorkflow = false; //AR7497+
    String workflowName = ""+ routingMap.get("WorkflowName");
    if(workflowName.equals(com.xerox.docushare.routing.DSRouting.DELETEDWORKFLOWNAME))
        deletedWorkflow = true; //AR7497+
    
    try {
        if ((byDateStr != null) && !("".equals(byDateStr))) {
            try {
                String dateFormat = MessageDB.get("date_short_4"+keySuffix, locale); //AR13364+
                Date byDate = RoutingUtil.parseDate(byDateStr, locale, dateFormat); //AR7513+ //AR13364+ dateFormat
                //System.out.println("byDateStr = "+ byDateStr + ", new byDate = " + byDate);

                Date oldByDate = (Date)routingMap.get("ByDate"); //dsrouting.getWorkFlowByDate(routingSlip);
                if ((oldByDate != null) && !oldByDate.equals(byDate)) {
                    if(dsrouting.setWorkFlowByDate(routingSlip, byDate)) {
                        routingMap.put("ByDate", byDate); //AR7513+
                        refreshOpener = true;
                    }
                }
            } catch (java.text.ParseException ex) {
                status = null;
%>
<script language="javascript">
<!--
            window.alert("<%= MessageDB.get("info.detail.invalid_date", locale) %>");
//-->
</script>
<%
            }
        }

        if (refreshOpener) {%>
            <script language="javascript">
            <!--
            // update the My Tasks Assigned To/By Me pane if open
            var win = (<%= routingSlipRequestID != null %>) ? updateMyTasksAssignedToMe() : updateMyTasksAssignedByMe();

            // if not launched from that pane, also refresh our opener
            if (self.opener && (self.opener != win)) {
                self.opener.location = self.opener.location;
            }
            //-->
            </script>
        <%}
        if (closeWindow) {%>
            <script language="javascript">
            <!--
            window.close();
            //-->
            </script>
        <%} else {
        %>
<script language="javascript">
//AR4909 added below function:
function allcomment(routingSlip)
{   var attributes = "toolbar=no,location=no,directories=no,status=yes,menubar=yes,scrollbars=yes,copyhistory=no,resizable=yes,width=600,height=600";
    var win = window.open("savecomment.jsp?routingSlip="+routingSlip, "savecomment", attributes);
    win.onClose = restoreFocus;
    win.focus();
}

//AR4909 moved most code of below function into savecomment.jsp:
<%
List recipientArray = (ArrayList)routingMap.get("TaskID_Recipients");
Collections.sort(recipientArray, new StepComparator());//AR35868
Iterator recipientItr = recipientArray.iterator();
for (; recipientItr.hasNext(); ) {
  String tid_rec = (String)recipientItr.next(); //format: "tid_uid: taskname"
  tid_rec = tid_rec.substring(0, tid_rec.indexOf(':'));
  String aRecipient = tid_rec.substring(tid_rec.indexOf('_')+1);

  String aRecipientName = dsrouting.getUserFullName(aRecipient);
  if(aRecipientName.startsWith("routing_")) //routing_deleted, routing_no_access
    aRecipientName = routingMap.get(aRecipient + "_fullname") + " ("+ MessageDB.get(aRecipientName, locale)+")"; //AR13848

  String comments = (String)routingMap.get(tid_rec+"_Comment"); //dsrouting.getRecipientComment(routingSlip, aRecipient);
  if(comments != null && comments.length() > 0){
    iCommentCount++;
    break;
  }
}
%>
</script>

<body onLoad="window.bodyLoaded()">
    <div id="header">
        <h1>DocuShare</h1>
        <h2>Routing Report</h2>
        <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
    </div>

    <div id="content">
    <h2><%= reportTitle %></h2>    

<form name="routingForm" action="report_base.jsp" target="_top" method="GET">
<!-- AR6223+ --><input type="hidden" name="reportType", value="<%=reportType%>" />
<%if(notifyID != null){%>
  <input type="hidden" name="notifyID", value="<%=notifyID%>" />
<%}%>
<p>
<%
            String subject = (String)routingMap.get("Subject"); //dsrouting.getSubject(routingSlip);
            String owner = (String)routingMap.get("Owner"); //dsrouting.getWorkFlowOwner(routingSlip);
            if(recipient.equals(owner)) isOwnerOrAdmin = true; //AR6391+
            //AR7012-:DSUser dsOwner = (DSUser)dsSession.getObject(new DSHandle(owner));
            //AR7012+:
            String ownerName = dsrouting.getUserFullName(owner);
            if(owner==null || owner.equals("null")) owner = "";
        		if(ownerName.startsWith("routing_")) { //AR13848
            String ownerName_save = (String)routingMap.get("OwnerName");
            if (ownerName_save != null && ownerName_save.length() > 0)
                ownerName = ownerName_save + " ("+ MessageDB.get(ownerName, locale)+")";
            else
            		ownerName = owner + " ("+ MessageDB.get(ownerName, locale)+")";
        }

            Date dueDate = (Date)routingMap.get("ByDate"); //dsrouting.getWorkFlowByDate(routingSlip);
            boolean isOverdue = ((dueDate != null) && !dueDate.after(new Date()));

            String routingStatus = (String)routingMap.get("RoutingStatus"); //dsrouting.getRoutingStatus(routingSlip);
            routingStatus = dsrouting.getLocalizedStatus(routingStatus, locale);
            boolean jobRunning = false;
            int job = routingSlip;
            if (job != 0) {
                //String jobStatus = dsrouting.getRoutingStatus(job);
                jobRunning = dsrouting.isJobRunning(job); //dsrouting.JOB_RUNNING.equals(jobStatus);
            }

            // use first document if subject not specified

            if (subject.length() == 0) {
                //if(dsrouting.getDocuments(routingSlip).iterator().hasNext())
                //    String doc = (String)dsrouting.getDocuments(routingSlip).iterator().next();
                Iterator itrDoc = ((ArrayList)routingMap.get("Documents")).iterator();
                if(itrDoc.hasNext()){
                    String doc = (String)itrDoc.next();
                    try{
                        DSHandle dsHandle = new DSHandle(doc);
                        DSObject dsObj = dsSession.getObject(dsHandle, new DSSelectSet(DSObject.title)); //AR13400
                        if (dsObj instanceof DSVersion) {
                            // get document from version
                            dsObj = ((DSVersion)dsObj).getDocument(DSSelectSet.NO_PROPERTIES);
                        }
                        // use the first document as the subject if no subject given
                        subject = dsObj.getTitle();
                    }catch(Exception e1) {
                        try{
                            ArrayList docTitleArray = (ArrayList)routingMap.get("DocTitleArray");
                            if(docTitleArray!=null && docTitleArray.size()>0) 
                                subject = (String)docTitleArray.get(0);
                            //else subject = doc;
                        }catch(Exception e2) {}
                    }
                }
            }//if(subject.length()==0)

            if (aboutRecipient != null) {
                // this is a response from a recipient
                String aboutRecipientName = dsrouting.getUserFullName(aboutRecipient);
                if(aboutRecipientName.startsWith("routing_")) //routing_deleted, routing_no_access
                  aboutRecipientName = aboutRecipient + " ("+ MessageDB.get(aboutRecipientName, locale)+")";
                %>
                <b><%= MessageDB.get("prop.label.linksFromAbbr", locale) %>:</b>&nbsp;<%= aboutRecipientName %><br>
                <%
            } else {
                // this is a report from the document routing service
                %>
                <strong><%= MessageDB.get("prop.label.linksFromAbbr", locale) %>:</strong>&nbsp;<%= MessageDB.get("routing_service", locale) %><br />
                <%
            }
            %>
            
            <strong><%= MessageDB.get("routing_subject", locale) %>:</strong>&nbsp;Re:&nbsp;<%= AmberUtility.xss_safe_value(subject) %><br />
            <%
            if (!recipient.equals(owner)) {
            %>
            <strong><%= MessageDB.get("routing_originator", locale) %>:</strong>&nbsp;<%= ownerName %><br />
            <%
            }

            Date titleDate = null;
            if (aboutRecipient != null) {
                // for reporting on user, use the time when the status for this user was set
                //titleDate = dsrouting.getRecipientStatusTime(routingSlip, aboutRecipient);
                titleDate = (Date)routingMap.get(aboutTask+"_"+aboutRecipient+"_StatusTime");
            } else {
                // for reporting on job, use the time when the routingslip job was created
                titleDate = (Date)routingMap.get("CreationTime"); //dsrouting.getWorkFlowJobCreationTime(routingSlip);
            }
            // only show date if available (not available if job no longer exists)
            if (titleDate != null) {
                // Singapore team AR3594 in International English version  due date is not right 
                String titleDateStr = new SimpleDateFormat(MessageDB.get("date_time_full"+keySuffix, locale), locale).format(titleDate);
                %>
                <strong><%= MessageDB.get("date_label", locale) %>:</strong>&nbsp;<%= titleDateStr %><br />
                <%
            }
            if (dueDate != null) {
                String docbase = contextPath + "/"; // AR 4785 Send docbase into show_calendar                   
                %>
                <strong><%= MessageDB.get("routing_due_date", locale) %>:</strong>&nbsp;
                <%
                /* Singapore team AR3449 in french release, duedate in Routing doesn't work */
                //String dueDateStr = java.text.DateFormat.getDateInstance(java.text.DateFormat.SHORT, locale).format(dueDate);
                String dueDateStr = new SimpleDateFormat(MessageDB.get("date_short_4"+keySuffix, locale), locale).format(dueDate);
                /* Singapore team AR3449 */

                // due date of running job can only be changed by owner
                if (!jobRunning || isOverdue) {//AR19777 add isOverdue
                    %>
                    <%= dueDateStr %>
                    <%
                } else {
                    if (!recipient.equals(owner) || aboutRecipient!=null) { //AR6223+ " || aboutRecipient!=null"
                        %>
                        <%= dueDateStr %>
                        <%
                    } else {
                        String strCalDate = MessageDB.get("routing.report_base.cal_date", locale);
                        %>
                        <nobr>
                        <%// Singapore Team AR2485 re-schedule ovedue date has to hit return to make it work %>
                        <input type="text" name="byDate" size="<%= isOlderNetscape ? "12" : "18" %>" value="<%= dueDateStr %>"
                         onChange="if(byDate.value.length==10) document.routingForm.submit(); else byDate.value='<%=dueDateStr%>';">
                        <%// Singapore Team AR2485 %>
                        <!--
                        <A HREF="javascript:showCalendar(routingForm.byDate)">
                        -->
                        <A HREF="#" onClick="show_calendar('routingForm.byDate','<%= MessageDB.get("date_short_4"+keySuffix, locale) %>', '<%= docbase %>', datePicked); return false">
                        <IMG SRC="<%= contextPath %>/images/calendar.gif" alt="<%= strCalDate %>" title="<%= strCalDate %>" BORDER="0"></A>
                        (<%= MessageDB.get("form.date.formatter.forDisplay"+keySuffix, locale) %>)
                        <%
                    }
                    // mark overdue if running and past due time
                    if (isOverdue) {
                        /* Singapore team AR3568 on Solaris,in Spanish Release 5, word 'overdue' is not translated */
                        %>
                        <font color="red"><strong>&nbsp;(<%=MessageDB.get("routing_overdue", locale)%>)</strong></font>
                        <%/* Singapore team AR3568*/
                    }
                }
            }
            %>
            <br /> 
            </p>
            <p>
            <%= AmberUtility.xss_safe_value(((String)routingMap.get("Body")).replaceAll("\r","<br>")) %>
            <p>
            
    <table class="colltable">
        <col class="col_actions" />
        <col class="col_actions" />
        <tr>
            <th><%=MessageDB.get("routing_type", locale)%></th>
            <th class="name"><%=MessageDB.get("routing_title", locale)%></th>
            <th class="actions"><%=MessageDB.get("Actions", locale)%></th> 
        </tr>
            
            <%
            // display list of documents
            DSURLInfo urlInfo = (DSURLInfo) request.getAttribute("DSURLInfo");
            boolean first = true;
            int unpublishedCount = 0;

            // TODO (PJG) NEED EXCEPTION HANDLING HERE
            //System.out.println("report_base line 598 getDraftsForUser");
            //when aboutRecipient==null, below will show routed versions:
            ArrayList docTitleArray = (ArrayList)routingMap.get("DocTitleArray");
            ArrayList docList = (ArrayList)routingMap.get("Documents");
            if(docList == null) docList = new ArrayList();
            for(int n=0; n<docList.size(); n++){
                boolean isDraft = false;
                String docEntry = (String)docList.get(n);
                String draft = ""+ routingMap.get(docEntry+ "_RoutedVersion");
                //System.out.println("report_base.jsp: docEntry = "+ docEntry +", draft = " + draft);
                String myDraft = (String)routingMap.get(docEntry+ "_"+ aboutRecipient);
                if(myDraft != null) draft = myDraft;
                
                String errMsg = "";
                
                //DSHandle draftHandle = null;
                DSHandle draftHandle = new DSHandle(draft);
                DSObject dsObj = null;
                DSDocument dsDocument = null;
                DSVersion dsVersion = null;
                String versionFileName = "";
				String lostSimpleDocTitle = null; //AR23531
                try {
                    //draftHandle = new DSHandle(draft);
                    dsObj = dsSession.getObject(draftHandle, new DSSelectSet(new String[] 
                        {DSObject.summary, DSObject.title, DSObject.isRecord})); //AR13400
                    if(dsObj instanceof DSDocument){
                      dsDocument = (DSDocument)dsObj;
                      dsVersion = dsDocument.getPreferredVersion(null);
                      //update draft and draftHandle to version's:
                      draftHandle = dsVersion.getHandle();
                      draft = draftHandle.toExternalForm();
                    }else if(dsObj instanceof DSVersion){
                      dsVersion = (DSVersion)dsObj;
                      dsDocument = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);
                    }

					//AR23531: try to look for the 1st version of the SimpleDoc, this is to handle old workflow created on SimpleDoc before AR23531 is fixed
					if( (""+dsVersion.getHandle()).startsWith("v_Document-") && !dsSession.isSimpleDoc( ( ( DSDocument ) dsDocument ).getHandle() ) ){
					
					
						DSObjectIterator versionsIter = dsDocument.getDestinations( new String[]{ DSLinkDesc.version, DSLinkDesc.draftVersion }, 1, new DSSelectSet(new String[] {DSVersion.version_number}) );
						boolean foundFirst = false;
						while (versionsIter.hasNext())
						{
							DSVersion dsVer = (DSVersion) versionsIter.next();
							if(dsVer.getVersionNumber() == 1)
							{
								dsObj = dsSession.getObject(dsVer.getHandle(), new DSSelectSet(new String[] {DSObject.summary, DSObject.title, DSObject.isRecord})); //AR13400
					              		if(dsObj instanceof DSDocument){
					                      		dsDocument = (DSDocument)dsObj;
					                      		dsVersion = dsDocument.getPreferredVersion(null);
					                      		//update draft and draftHandle to version's:
					                      		draftHandle = dsVersion.getHandle();
					                      		draft = draftHandle.toExternalForm();
					                    	}else if(dsObj instanceof DSVersion){
					                      		dsVersion = (DSVersion)dsObj;
					                      		dsDocument = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);
									draftHandle = dsVersion.getHandle();
					                      		draft = draftHandle.toExternalForm();
					                    	}
								foundFirst = true;
								break;
							}
						}
						if (!foundFirst)
						{
							errMsg = " ("+MessageDB.get("routing_deleted", locale)+")";
							lostSimpleDocTitle = dsDocument.getTitle()+errMsg;
							dsObj = null;
							dsDocument = null;
							dsVersion = null;
						}
					}

                    // get preferred file name for use in GET request
                    if(dsVersion != null) {
                        versionFileName = dsVersion.getPreferredRendition(DSSelectSet.NO_PROPERTIES).getContentElements()[0].getPreferredFileName();
                        versionFileName = dsrouting.removePoisonChars(versionFileName); //AR11042+
                    }
                } 
                catch(DSException e) {//AR18174+
		    		String errStr = "" + e;
				    if(e.errorCode == DSException.NOT_FOUND) {
				    	boolean deleted = false;
				    	try{
					    	deleted = dsSession.isDeletedObject(draftHandle);
				    	}
				    	catch (DSAuthorizationException aex){
					    	errMsg = " ("+MessageDB.get("routing_no_access", locale)+")"; 
							System.out.println("report_base.jsp display list of documents "+ draft +": errorCode " + e.getErrorCode() + ", " + aex);
				    	}
				        catch (DSException ex){
					    	deleted = true;
					    	System.out.println("report_base.jsp display list of documents "+ draft +": errorCode " + e.getErrorCode() + ", " + ex);
				    	}
				        if (deleted)
				     	{
					    	errMsg = " ("+MessageDB.get("routing_deleted", locale)+")";
							System.out.println("report_base.jsp display list of documents "+ draft +": errorCode " + e.getErrorCode() + ", " + e);
				    	}
				    	else
					    	System.out.println("report_base, "+ draft +": " + errStr);
                    } else
                    	System.out.println("report_base, "+ draft +": " + errStr);
            	}
            	catch(Exception e) { System.out.println("report_base, "+ draft +": " + e); }

                // get the icon, title and summary for the draft version
                String docIcon = contextPath + "/images/small/page.png";
                if (urlInfo != null) {
                    try {
                        java.net.URL docIconURL = new java.net.URL(urlInfo.getURLInfo(draftHandle)[0]);
                        docIcon = docIconURL.getPath();
                    } catch (Exception ex) {
                    }
                }
				String errTitle = draft;
                if(docTitleArray!=null && docTitleArray.size()>n)
                    errTitle = (String)docTitleArray.get(n);
                String docTitle = errTitle+errMsg;
				if (lostSimpleDocTitle != null) //AR23531
					docTitle = lostSimpleDocTitle;
                String docSummary = null;
                if(dsDocument != null){
                    docTitle = dsDocument.getTitle(); //AR6175: dsVersion->dsDocument
                    docSummary = dsDocument.getSummary(); //AR6175: dsVersion->dsDocument
                }else if(dsObj != null){
                    docTitle = dsObj.getTitle();
                    docSummary = dsObj.getSummary();
                }
                first = false;
                %>
        <tr>
            <td class="icon">
                <% //AR8786+:
                String GetOrView = "/dsweb/Get/" + draft + "/";
                try{
                    if(dsDocument == null) //AR12002+
                        GetOrView = "/dsweb/View/" + draft + "/";
                    else //dsDocument not null
                        if(dsDocument.getIsInteract()) GetOrView = "/dsweb/View/" + dsDocument.getHandle().toString() + "/";
                }catch(Exception e0) { System.out.println("dsDocument.getIsInteract(): "+ e0); }
                //end AR8786

                if(errMsg.length()==0) { //AR4556+ 
                  %>
                  <!-- AR8786 DSDE: fix interact page routing -->
                  <a href="<%= contextPath + GetOrView + versionFileName %>" target="_new">
                <%}
                String strEdit = MessageDB.get("routing.report_base.edit", locale);
                %>
                <img <%= browserInfo.getImgWrapper(docIcon) %> alt="<%= MessageDB.get("Document", locale) %>" title="<%= MessageDB.get("Document", locale) %>" border="0" />
                </a>
            </TD>
            
            <td class="name">
                <% 
                if(errMsg.length()==0) { //AR4556+ 
                  %>
                  <!-- AR8786 DSDE: fix interact page routing -->
                  <a class="VariableWidth9URL" href="<%= contextPath + GetOrView + versionFileName %>" target="_new">
                <%}%>
                <%= AmberUtility.xss_safe_value(docTitle) %>
                </a>
                <%
                // show "New" icon if this is a new draft version
                // that was added by the specified recipient
                try {
                    // Singapore team AR4572 Unpublished doesn't appear in Report on Routing window
                    String workFlowID = workFlowJobName;
                    if (workFlowID != null) {
                        DSDocument dsDoc = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);
                        isDraft = dsDoc.isDraft();
                        if (   (aboutRecipient == null)  // only show on summary report
                            && dsDoc.isDraft()) {
                            //AR7825-: && (dsrouting.getWorkFlowJobsForDocument(dsDoc.getHandle().toExternalForm()).length <= 1)
                            unpublishedCount++;
                            %>
                            <%// Singapore team AR2661 remove publish hint %>
                            <font color="red"><strong>&nbsp;(<%= MessageDB.get("routing_unpublished", locale) %>)</strong></font>
                            <%
                        }
                        if((dsVersion.getOwner(DSSelectSet.NO_PROPERTIES).getName().equals(aboutRecipient))
                          && (!dsVersion.getHandle().toExternalForm().equals(dsrouting.getBaseDraftForWorkflow(Integer.parseInt(workFlowJobName)
                          , dsDoc.getHandle().toExternalForm() )))){ //AR4862+
                            String strNew = MessageDB.get("routing.report_base.new", locale);
                          %>
                          <img src="<%= contextPath %>/<%= locale %>/images/new.gif" alt="<%= strNew %>" title="<%= strNew %>" border="0">
                          <%
                        }
                    }
                } catch (Exception ex) {
                    // do nothing
                }

                if (docSummary != null) {
                    %>
                    <p><%= AmberUtility.xss_safe_value(docSummary) %></p>
                    <%
                }
                %>
            </td>

            <td class="actions"> 
                <%
                String sProperties = MessageDB.get("routing_tooltip_properties", locale); //SDL AR9150+
                String sViewHTML = MessageDB.get("routing_tooltip_view_html", locale); //SDL AR9150+
                
                if(errMsg.length()==0) {
                    if(dsDocument == null) {//AR12002+ %>
<a href="<%= contextPath %>/dsweb/Services/<%= draft %>" target="_new">
                    <%}else{%>
<a href='prop_all.jsp?document=<%= draft %>&return=<%= java.net.URLEncoder.encode("report_base.jsp?" + request.getQueryString(), "UTF-8") %>&returnTag=<%= java.net.URLEncoder.encode(reportTitle, "UTF-8") %>&<%= request.getQueryString() %>'>
                    <%}
                }%>
<img <%= browserInfo.getImgWrapper(contextPath + "/images/action_properties.gif") %> alt="<%=sProperties%>" title="<%=sProperties%>" border="0" /></a>

                <% //AR9128+:
                if(errMsg.length()==0 && isDraft && !jobRunning) {
                    String sRoute = MessageDB.get("routing_route", locale); //"Route";                
                %>
<script type="text/javascript" src="<%=contextPath%>/javascript/common/ds_routing.js"> </script>
<a href="javascript:openRoutingSlip('<%=contextPath%>/', '<%= docEntry %>')">
<img <%= browserInfo.getImgWrapper(contextPath + "/images/action_routing.gif") %> alt="<%=sRoute%>" title="<%=sRoute%>" border="0" /></a>
                <%} //end AR9128+ %>
                
<% // Singapore team AR2768 Hide remark from enduser // Singapore team AR2658 Remove sub-route icon 
              try{ //AR3494
                boolean enableHtmlview = jp.co.fujixerox.docushare.amber.ConfigManager.getInstance().getDSConfig().enableHtmlview (dsSession); //AR8883+
                boolean isRecord = true;
                if(dsVersion != null)
                    isRecord = dsVersion.getIsRecord();
                else
                    isRecord = dsObj.getIsRecord();
                enableHtmlview = enableHtmlview && !isRecord; //AR9778+
                if (enableHtmlview && urlInfo.is_viewable(draftHandle) && errMsg.length()==0) {%>
<a href="<%= contextPath %>/dsweb/Get/<%= draft %>/html" target="_new">
<img <%= browserInfo.getImgWrapper(contextPath + "/images/action_viewweb.gif") %> alt="<%=sViewHTML%>" title="<%=sViewHTML%>" border="0" /></a>
                <%}
                /* AR15049-: //AR9639 PDF icon:
                String sourceMimeType = dsVersion.getPreferredRendition(new DSSelectSet(DSRendition.rendition_type)).getRenditionType();
                boolean viewPdf = dsSession.canConvert(sourceMimeType, "application/pdf") && !isRecord;
                String sViewPDF = MessageDB.get("routing_tooltip_view_pdf", locale);
                if (viewPdf && errMsg.length()==0) {%>
                    <a href="<%= contextPath %>/dsweb/Get/<%= draft %>/pdf" target="_new">
                    <img <%= browserInfo.getImgWrapper(contextPath + "/images/action_viewPDF.gif") %> alt="<%=sViewPDF%>" title="<%=sViewPDF%>" border="0" /></a>
                <%}
                //end AR9639*/
              }catch(Exception e) { //System.out.println("urlInfo.is_viewable("+draftHandle+"): "+ e); 
              } //AR3494
              %>
</TD>
</TR>
<%
            }//end for (Iterator docItr = dsrouting.getDraftsForUser)
%>
</TABLE>

<%// Singapore team AR2661 Add italic publish hint
//if(unpublishedCount > 0) { //AR5042-
if(unpublishedCount > 0 && !reportType.endsWith("Completion")) { //AR5042+
%>
<p class="note"><%= MessageDB.get("routing_publish_hint", locale) %></p>
<%}// Singapore team AR2661
            // report documents removed
            //if (dsrouting.isDocumentRemoved(routingSlip)) {
            if (false) {//AR7113-: routingMap.get("isDocumentRemoved")!=null)
%>
<p class="note">
<font color="red"><%= MessageDB.get("routing_error_docs_removed", locale) %></font></p>
<%
            }

            // display report about specified recipient
            if (aboutRecipient != null) {
                //System.out.println("report_base line 750, aboutRecipient != null");
                String tid_rec = aboutTask+"_"+aboutRecipient;
                
                /* Singapore team AR3518 in french release, type of route slip are not translated */
                //String recipientStatus = dsrouting.getRecipientStatus(routingSlip, aboutRecipient);
                String recipientStatus = (String)routingMap.get(tid_rec+"_Status");
                if(recipientStatus == null) recipientStatus = "";                
                if(recipientStatus.equals("Approved")){
                    recipientStatus = MessageDB.get("routing_approved", locale);
                }else if(recipientStatus.equals("Disapproved")){
                    recipientStatus = MessageDB.get("routing_disapproved", locale);
                }else if(recipientStatus.equals("Reviewed")){
                    recipientStatus = MessageDB.get("routing_reviewed", locale);
                }else if(recipientStatus.equals("Acknowledged")){
                    recipientStatus = MessageDB.get("routing_acknowledged", locale);
                }
%>
<p><strong><%= MessageDB.get("routing_response", locale) %>:</strong>&nbsp;<%=recipientStatus%></p>
<%
                /* Singapore team AR3518 */
                //String comments = dsrouting.getRecipientComment(routingSlip, aboutRecipient);
                String comments = (String)routingMap.get(tid_rec+"_Comment");
                if ((comments == null) || (comments.trim().length() == 0)) {
%>
<p><strong><%= MessageDB.get("comment_label", locale) %>:</strong>&nbsp;<%= MessageDB.get("None", locale) %></p>
<%
                } else {
%>

<p><strong><%= MessageDB.get("comment_label", locale) %>:</strong>&nbsp;<%= AmberUtility.xss_safe_value(comments.replaceAll("\r","<br>")) %></p>
<%
                }

            // display report about all recipient status
            } else {
%>
<p><strong><%=MessageDB.get("routing_status", locale)%>:</strong>&nbsp;<%= routingStatus %></p>

<table class="colltable">
<col class="col_actions" />
<col class="col_actions" />
<col class="col_actions" />

<tr>
<TH>&nbsp;</TH>
<TH class="name"><%= MessageDB.get("routing_recipient", locale) %></TH>
<TH class="name"><%= MessageDB.get("routing_response", locale) %></TH>
<TH class="name"><%= MessageDB.get("date_label", locale) %></TH>
</TR>
<%
                // display list of recipients
                first = true;
                String step0 = "";
                //System.out.println("report_base line 799 display list of recipients");
 				List recipArray = (ArrayList)routingMap.get("TaskID_Recipients");				
				Collections.sort(recipArray, new StepComparator());//AR35868
				Iterator recipItr = recipArray.iterator();
                for (; recipItr.hasNext(); ) {
                    String tid_rec = (String)recipItr.next(); //format: "tid_uid: Review (1.2)"
                    String step = "";
                    try{ step = tid_rec.substring(tid_rec.indexOf('(')+1, tid_rec.indexOf('.'));
                    }catch(Exception estep) {}
                    tid_rec = tid_rec.substring(0, tid_rec.indexOf(':'));
                    String aRecipient = tid_rec.substring(tid_rec.indexOf('_')+1);
                    String aTask = tid_rec.substring(0, tid_rec.indexOf('_'));
                    String aRecipientName = dsrouting.getUserFullName(aRecipient);
                    if(aRecipientName.startsWith("routing_")) //routing_deleted, routing_no_access
                      aRecipientName = routingMap.get(aRecipient + "_fullname") + " ("+ MessageDB.get(aRecipientName, locale)+")"; //AR13848
         
                    //String aStatus = dsrouting.getRecipientStatus(routingSlip, aRecipient);
                    String aStatus = (String)routingMap.get(tid_rec+"_Status");
                    /* Singapore team AR3518 in french release, type of route slip are not translated */
                    if(aStatus != null){
                        if(aStatus.equals("Approved")){
                            aStatus = MessageDB.get("routing_approved", locale);
                        }else if(aStatus.equals("Disapproved")){
                            aStatus = MessageDB.get("routing_disapproved", locale);
                        }else if(aStatus.equals("Reviewed")){
                            aStatus = MessageDB.get("routing_reviewed", locale);
                        }else if(aStatus.equals("Acknowledged")){
                            aStatus = MessageDB.get("routing_acknowledged", locale);
                        }
                    }
                    String skip = MessageDB.get("routing_skip", locale); //"[Skip]"
                    /* Singapore team AR3518 */
                    //Date aDate = dsrouting.getRecipientStatusTime(routingSlip, aRecipient);
                    Date aDate = (Date)routingMap.get(tid_rec+"_StatusTime");
                    if(aDate == null){
                        aDate = (Date)routingMap.get(tid_rec+"_SkipTime");
                        if (aDate != null) aStatus = skip;
                        else {//AR18710
                            aDate = (Date)routingMap.get(tid_rec+"_PassiveTime");
                            if (aDate != null) aStatus = skip;
                        }
                    }
                    //System.out.println(tid_rec + ": aStatus = "+ aStatus);
                    String aDateStr = "&nbsp;";
                    if (aDate != null) {
                        //AR8506-: aDateStr = java.text.DateFormat.getDateInstance(java.text.DateFormat.SHORT, locale).format(aDate);
                        aDateStr = new SimpleDateFormat(MessageDB.get("date_short_2"+keySuffix, locale)).format(aDate); //AR8506+
                    }
                    first = false;
                    
                    //add step info:
                    String stepActionOrder = (String)routingMap.get("StepActionOrder_"+step);
                    if(!step.equals(step0) && stepActionOrder!=null) {
                        //SDL AR+: //format "Step 1: ReviewOrderedNotShare, MajorityReply"
                        try{
                            String sStep="", sAction="", sReply="";
                            int idx1 = stepActionOrder.indexOf(": ");
                            if(idx1 != -1) {
                                sStep = MessageDB.get("routing_step", new Object[] {step}, locale);
                                sAction = stepActionOrder.substring(idx1 + 2);
                                int idx2 = sAction.indexOf(", ");
                                if(idx2 != -1) {
                                    sReply = MessageDB.get(sAction.substring(idx2 + 2), locale);
                                    sAction = sAction.substring(0, idx2);
                                }
                                //System.out.println("sAction = "+ sAction + ", sReply = "+ sReply);
                                sAction = MessageDB.get(sAction, locale);
                                stepActionOrder = sStep + ": " + sAction;
                                if(idx2 != -1) stepActionOrder += ", " + sReply;
                            }
                        }catch(Exception es) {System.out.println("report_base SDL: "+ es); }
                        //end SDL AR+
%>
<tr>
<td class="icon"> </td><td class="name"><%=stepActionOrder %></td>

</tr>
<%                      step0 = step;
                    }
                    //end add step info
%>
<tr>
<%
                    if (aStatus != null) {
                        //AR15052-: String userReportURL =  requestURL
                        String userReportURL = "report_base.jsp"
                               + "?reportType="+reportType+"&aboutRecipient="+ aRecipient+ "&aboutTask="+ aTask; //AR6223+
                               //AR6223-: + "?aboutRecipient=" + java.net.URLEncoder.encode(aRecipient, "UTF-8");
                        //AR23221 cause: missing workFlowJobName for ForReviewCompletion notification.
                        //AR23221 fix: "if" add && !reportType.endsWith("Completion"). Another fix: change "else if" to "if"
                        if (routingSlipRequestID != null && !reportType.endsWith("Completion")) {
                            // send routing slip request ID if this is a request
                            userReportURL += "&routingSlipRequestID=" + routingSlipRequestID;
                        } 
                        else if (workFlowJobName != null) {
                            // send workflow job name if this is not a request
                            userReportURL += "&workFlowJobName=" +  java.net.URLEncoder.encode(workFlowJobName, "UTF-8");
                        }
%>
<td class="icon">
<%
String strUser = MessageDB.get("routing.report_base.user", locale);

if(isOwnerOrAdmin && !aStatus.equals(skip)){//AR6391+ %>
<a href="javascript:openTaskDetailWindow('<%= userReportURL %>')">
<%}//end AR6391+ %>
<img src="<%= contextPath %>/images/small/user.png" alt="<%= strUser %>" title="<%= strUser %>" border="0" \>
</a>
</td>

<TD class="name">
<%if(isOwnerOrAdmin && !aStatus.equals(skip)){//AR6391+ %>
<a class="uline" href="javascript:openTaskDetailWindow('<%= userReportURL %>')">
<%}//end AR6391+ %>
<%= aRecipientName %>
</a>
</TD>

<TD class="name"><%= aStatus %></TD>
<TD class="name"><%= aDateStr %>&nbsp</TD>

<%
                    } else {
String strUser2 = MessageDB.get("routing.report_base.user", locale);                    
%>
<TD class="icon">
<img src="<%= contextPath %>/images/small/user.png" alt="<%= strUser2 %>" title="<%= strUser2 %>" border="0" \>&nbsp;
</TD>
<TD class="name">
<%= aRecipientName %>
</TD>
<TD class="name">
-
</TD>
<TD class="name">&nbsp;</TD>
<%
                    }
%>
</TR>
<%
                }
%>
</TABLE>
<%
//Singapore team AR3684 SPAR C17758 - Routing: Route in order does not expose user comments to recipients
if(iCommentCount > 0){ //AR13366-&& isOwnerOrAdmin
//AR4909 added routingSlip to below allcomment:
%>
<p><a href="javascript:allcomment(<%=routingSlip%>)"><%=MessageDB.get("routing_show_all_comments", locale)%></a></p>
<%
}
//Singapore team AR3684
                // report documents removed
                if (isRecipientRemoved) {//dsrouting.isRecipientRemoved(routingSlip)) {
%>
<p class="note"><font color="red"><%= MessageDB.get("routing_recipients_removed", locale) %></font></p>
<%
                }
            }
%>

<div id="buttonbar">
<%
            // allow recipient to acknowledge and delete request for a workflow job
            if ((routingSlipRequestID != null) && (workFlowJobName != null)) {
%>
<%if(!btnReadOnly){//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= acknowledgedStatus %>"  onClick="return confirmDeleteUnpublished(<%= unpublishedCount %>);" />&nbsp;
<%}//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= MessageDB.get("routing_acknowledge_later", locale) %>" onClick="window.close(); return false;" />
<%
            } else if (owner.equals(recipient)) {
                // owner can change due date if the job still running
                if (jobRunning) {
                    // special case use of report as a request
                    if (routingSlipRequestID != null) {
%>
<%if(!btnReadOnly){//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= acknowledgedStatus %>"  onClick="return confirmDeleteUnpublished(<%= unpublishedCount %>);" />&nbsp;
<%}//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= MessageDB.get("routing_acknowledge_later", locale) %>" onClick="window.close(); return false;" />
<%
                    } else {
                      //Singapore team AR4420: added if to show the terminate button
                      if(request.getParameter("aboutRecipient")!=null) {//AR6223-: reportType.equals("ForReviewReport") && 
                        //should not show terminate button
                      } else { //show terminate button
%>      
<%if(!btnReadOnly && !deletedWorkflow){//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= terminateThisJobStatus %>" onClick="return confirmTerminateJob()" />&nbsp;
<%}//AR6202+ %>
                      <%
                      }//end of Singapore team AR4420
                      %>
<input type="submit" name="<%= reportType %>" value="<%= closeStatus %>" onClick="window.close(); return false;" />
<!--
<input type="submit" name="<%= reportType %>" value="<%= closeStatus %>" />
-->
<%
                    }
                } else if (aboutRecipient != null) {
                // report about specific recipient
%>
<input type="submit" name="<%= reportType %>" value="<%= closeStatus %>" />
<%
                } else if (workFlowJobName != null) {
                // owner can delete job or keep for later if not running
%>
<%if(!btnReadOnly && !deletedWorkflow){//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= deleteThisJobStatus %>" onClick="return confirmDeleteUnpublished(<%= unpublishedCount %>)" />&nbsp;
<%}//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= btnReadOnly?closeStatus:MessageDB.get("routing_keep_for_later", locale) %>" onClick="window.close(); return false;" />
<%
                } else if (routingSlipRequestID != null) {
%>
<%if(!btnReadOnly){//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= acknowledgedStatus %>"  onClick="return confirmDeleteUnpublished(<%= unpublishedCount %>);" />&nbsp;
<%}//AR6202+ %>
<input type="submit" name="<%= reportType %>" value="<%= MessageDB.get("routing_acknowledge_later", locale) %>" onClick="window.close(); return false;" />
                } else {
                // report about specific routing slip
%>
<input type="submit" name="<%= reportType %>" value="<%= closeStatus %>" onClick="window.close(); return false;" />
<%
                }
            } else {
                // all others can only close
%>
<input type="submit" name="<%= reportType %>" value="<%= closeStatus %>" onClick="window.close(); return false;" />
<%
            }
            // send routingslip requestID on submit
            if (routingSlipRequestID != null) {
%>
<input type="hidden" name="routingSlipRequestID", value="<%= routingSlipRequestID %>" />
<%
            }
            // send workflow job name on submit
            if (workFlowJobName != null) {
%>
<input type="hidden" name="workFlowJobName", value="<%= workFlowJobName %>" />
<%
            }
            // send routing slip ID on submit
            if (routingSlipIDStr != null) {
%>
<input type="hidden" name="routingSlipID", value="<%= routingSlipIDStr %>" />
<%
            }
        }
%>
</div>
<input type="hidden" name="report_base", value="true" />
</form>
<p class="routing_wizard_copyright"><%= MessageDB.get("xerox_copyright", locale) %></p>
</div>
</body>
<%
    } catch (java.rmi.RemoteException ex) {
%>
<script language="javascript">
<!--
writeError(document, '<%= recipientName %>', 'Internal Error',
      'Error communicating with the routing slip processor.  Please notify DocuShare customer support.'
    + '<p>Reported error:<br><%= ex.getMessage().replace('\'','"') %>'
);
//-->
</script>
<%
    }
}

//out.print("<br>notifyID = "+ notifyID);
long t1 = System.currentTimeMillis();
out.print("\n<!-- "+(t1-t0)+" ms -->");
%>
</html>
